<?php

CLASS mgud extends RasioProject
{
	protected $set;
	protected $enableCk = true;
	protected $jenis = 37;

	public function __construct($config)
	{
		$this->getConfig($config);
		$this->validation();
		$this->set();
	}

	protected function set()
	{
		$this->set->em 			= $this->em;
		$this->set->modul 		= 'Master Gudang';
		$this->set->dBaseH 		= 'gudang';
		$this->set->dBaseD 		= false;
		$this->set->dBasePk 	= array('kd_gudang');
		$this->set->where 		= array();
		$this->set->dSort 		= 'asc';
		$this->set->form 		= $this->setForm();
		$this->set->clearForm 	= array();
		$this->set->notNull 	= array("nm_gudang");
		$this->set->grid 		= $this->setGrid();
		$this->set->cetak 		= $this->setPrint();
		$this->set->button 		= array("Save", "First", "Prev", "Next", "Last", "Browse", "Add", "Del", "Edit", "prinT");
		$this->set->addClear 	= true;
		return $this->set;
	}
	
	protected function setForm()
	{
		$form[] = array('row' => 0, 'col' => 25, "label" => array("name" => "Kode", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'kd_gudang', "size" => 9)));
		$form[] = array('row' => 25, 'col' => 25, "label" => array("name" => "Nama", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'nm_gudang', "size" => 30)));

		$form[] = array('row' => 50, 'col' => 220, "label" => false, "input" => array("type" => 'text',	'attr' => array("name" => 'nm_cabang', "size" => 30, 'readonly' => true)));
		$form[] = array('row' => 50, 'col' => 25, "label" => array("name" => "Profit Center", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'kd_cabang', "size" => 9, 'after' => 'load("cabang", "false", "loadDisplay")', 'display' => 'loadDisplay', 'target' => 'nm_cabang=>nm_cabang')));
		
		$form[] = array('row' => 75, 'col' => 25, "label" => array("name" => "Alamat", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'alamat', "size" => 40)));
		$form[] = array('row' => 100, 'col' => 25, "label" => array("name" => "&nbsp;", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'alamat2', "size" => 40)));
		$form[] = array('row' => 125, 'col' => 25, "label" => array("name" => "&nbsp;", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'alamat3', "size" => 40)));
		
		$form[] = array('row' => 150, 'col' => 25, "label" => array("name" => "Telp", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'telp', "size" => 30)));
		$form[] = array('row' => 175, 'col' => 25, "label" => array("name" => "Fax", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'fax', "size" => 30)));
		$form[] = array('row' => 200, 'col' => 25, "label" => array("name" => "Email", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'email', "size" => 30)));
		
		$form[] = array('row' => 225, 'col' => 220, "label" => false, "input" => array("type" => 'text',	'attr' => array("name" => 'nmac', "size" => 50, 'readonly' => true)));
		$form[] = array('row' => 225, 'col' => 25, "label" => array("name" => "Account", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'kdac', "size" => 10, 'after' => 'load("Mac", "false", "loadDisplay")', 'display' => 'loadDisplay', 'target' => 'nmac=>nmac', 'load' => 'detil')));
		
		$form[] = array('row' => 250, 'col' => 25, "label" => array("name" => "Keterangan", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'ket', "size" => 40)));

		$form[] = array('row' => 300, 'col' => 25, "label" => array("name" => "By", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'chusr', 'size' => 15, 'readonly' => true)));
		$form[] = array('row' => 300, 'col' => 500, "label" => array("name" => "Last", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'chtime', 'size' => 20, 'readonly' => true)));
		return $form;
	}
	
	protected function setGrid()
	{
		$kode = new Kode;
		$res->page 	= 50;
		$res->sortA = $kode->getPk($this->set->dBasePk);
		$res->sortT = 'asc';
		
		$res->attr[]	= array("label" => 'Kode', 'attr' => 'a.kd_gudang', "sort" => 'true', "width" => 70, 'align' => 'left');
		$res->attr[]	= array("label" => 'Nama', 'attr' => 'a.nm_gudang', "sort" => 'true', "width" => 300, 'align' => 'left');
		$res->attr[]	= array("label" => 'Keterangan', 'attr' => 'a.ket', "sort" => 'true', "width" => 200, 'align' => 'left');
		
		return $res;
	}
	
	protected function setPrint()
	{
		$kode = new Kode;
		$res->sortA = $kode->getPk($this->set->dBasePk);
		$res->sortT = 'asc';
		$res->width = '1900px';
		
		$res->attr[]	= array("label" => 'Kode', 'attr' => 'a.kd_gudang', "sort" => 'true', "width" => 200, 'align' => 'left', 'filter' => true);
		$res->attr[]	= array("label" => 'Nama', 'attr' => 'a.nm_gudang', "sort" => 'true', 'width' => 200, 'align' => 'left', 'filter' => true);
		$res->attr[]	= array("label" => 'Keterangan', 'attr' => 'a.ket', "sort" => 'true', 'align' => 'left', 'filter' => true);
		return $res;
	}
	
	public function Index()
	{
		$this->data = $this->set;
		$this->view = "default/index";
	}
	
	public function data()
	{
		$basic = new Basic;
		$this->data = $basic->data($_GET, $this->set);
		$this->view = "default/displayData";
		$this->layout = "view";
	}
	
	public function Find()
	{
		$basic = new Basic;
		$this->data = $basic->find($_GET, $this->set);
		$this->view = "default/displayForm";
		$this->layout = "view";
	}
	
	protected function validasi()
	{
		$basic = new Basic;
		$error[] = $basic->validasiBasic($_POST, $this->set);
		return $basic->getError($error);
	}

	protected function kode($post)
	{
		$kode  = new Kode;
		$basic = new Basic;
		$this->set->prefik = 'GD.';
		return $basic->getAutoNumber($this->set, 3);
	}
	
	public function proses()
	{
		$basic = new Basic;
		$validasi = $this->validasi();
		if($validasi == true){
			$tambah = array();
			
			$_POST['kd_gudang'] = trim($_POST['kd_gudang']);
				
			if($_POST['_prosesAction'] == 'simpan'){
				if(empty($_POST['kd_gudang'])){
					$_POST['kd_gudang'] = $this->kode($_POST);
				}
			}
			
			if(!empty($_POST['kd_gudang'])){
				$basic->proses($_POST, $this->set, $tambah);
			}else{
				echo "<script>$('#_displayErrorPopUp').html('Kode tidak boleh kosong')</script>";
				$error[] = false;
			}
		}
		$this->layout = "null";
	}
	
	public function Delete()
	{
		$basic = new Basic;
		$this->data = $basic->delete($_GET, $this->set);
		$this->layout = "null";
	}
	
	public function cetak()
	{
		$basic = new Basic;
		$this->data->data = $basic->printer($_GET, $this->set);
		$this->data->width = $this->set->cetak->width;
		$this->view = "default/cetak";
		$this->layout = "print";
	}
	
	public function load()
	{
		$basic = new Basic;
		$this->data = $basic->load($_GET, $this->set);
		$this->layout = "null";
	}
	
	public function bank()
	{
		$data = $this->em->getFind("sub", "nm_sub", array("kd_sub = '".$_GET['idRef']."'"));
		
		$res->target = $_GET['target'];
		$res->nama 	= $data->nm_sub;
		echo json_encode($res);
		$this->layout = "null";
	}
	
	public function popUp()
	{
		$basic = new Basic;
		$this->data = $basic->data($_GET, $this->set);
		$this->view = "default/displayDataPopUp";
		$this->layout = "view";
	}
	
	public function Disdefload()
	{
		$data = $this->em->getFind("gudang", "nm_gudang", array("kd_gudang = '".$_GET['idRef']."'"));
		
		$res->target = $_GET['target'];
		$res->nama 	= $data->nm_gudang;
		echo json_encode($res);
		$this->layout = "null";
	}
	
	public function loadDisplay()
	{
		$pk = $this->set->dBasePk[0];
		$data = $this->em->getFind($this->set->dBaseH, '*', array("$pk = '".$_GET['idRef']."'"));
		$basic = new Basic;
		$res = $basic->loadDisplay($data, $_GET);
		echo json_encode($res);
		$this->layout = "null";
	}
	
	public function Select()
	{
		// $data = $this->em->getFindBy($this->set->dBaseH, "kd_gudang as kode, kd_gudang||'___'||'___'||kdac||'___'||nmac as nama", array(), "kd_gudang");
		// $data = $this->em->getFindBy($this->set->dBaseH, "kd_gudang as kode, kd_gudang||'___'||nm_gudang||'___'||kdac||'___GUDANG' as nama", array(), "kd_gudang");
		
		$sql = $this->em->addSelect("a.kd_gudang as kode, a.kd_gudang||'___'||a.nm_gudang||'___'||a.kdac||'___'||b.nmac as nama");
		$sql = $this->em->getFrom('gudang', 'a');
		$sql = $this->em->addLeftJoin('acc', 'b', array("a.kdac = b.kdac"));
		$sql = $this->em->getMultiSort('a.kd_gudang');
		$eks = $this->em->queryEks($sql);
		$data = $this->em->getFetchObject($eks);
		
		$res->jum 	= count($data);
		$res->data 	= $data;
		$res->div 	= strtoupper($_GET['idDiv']);
		
		echo json_encode($res);
		$this->layout = "null";
	}
}